package cn.iocoder.yudao.module.server.service.materialdownloadlog;

import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import cn.iocoder.yudao.module.server.controller.admin.materialdownloadlog.vo.*;
import cn.iocoder.yudao.module.server.dal.dataobject.materialdownloadlog.MaterialDownloadLogDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;

import cn.iocoder.yudao.module.server.dal.mysql.materialdownloadlog.MaterialDownloadLogMapper;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.server.enums.ErrorCodeConstants.*;

/**
 * 资料下载日志 Service 实现类
 *
 * @author TRS
 */
@Service
@Validated
public class MaterialDownloadLogServiceImpl implements MaterialDownloadLogService {

    @Resource
    private MaterialDownloadLogMapper materialDownloadLogMapper;

    @Override
    public Long createMaterialDownloadLog(MaterialDownloadLogSaveReqVO createReqVO) {
        // 插入
        MaterialDownloadLogDO materialDownloadLog = BeanUtils.toBean(createReqVO, MaterialDownloadLogDO.class);
        materialDownloadLogMapper.insert(materialDownloadLog);
        // 返回
        return materialDownloadLog.getId();
    }

    @Override
    public void updateMaterialDownloadLog(MaterialDownloadLogSaveReqVO updateReqVO) {
        // 校验存在
        validateMaterialDownloadLogExists(updateReqVO.getId());
        // 更新
        MaterialDownloadLogDO updateObj = BeanUtils.toBean(updateReqVO, MaterialDownloadLogDO.class);
        materialDownloadLogMapper.updateById(updateObj);
    }

    @Override
    public void deleteMaterialDownloadLog(Long id) {
        // 校验存在
        validateMaterialDownloadLogExists(id);
        // 删除
        materialDownloadLogMapper.deleteById(id);
    }

    private void validateMaterialDownloadLogExists(Long id) {
        if (materialDownloadLogMapper.selectById(id) == null) {
            throw exception(MATERIAL_DOWNLOAD_LOG_NOT_EXISTS);
        }
    }

    @Override
    public MaterialDownloadLogDO getMaterialDownloadLog(Long id) {
        return materialDownloadLogMapper.selectById(id);
    }

    @Override
    public PageResult<MaterialDownloadLogDO> getMaterialDownloadLogPage(MaterialDownloadLogPageReqVO pageReqVO) {
        return materialDownloadLogMapper.selectPage(pageReqVO);
    }

}